3 # Copyright (c) 2005 Junio C Hamano.
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git-rebase --continue | --abort | --skip | --edit-todo
15 v,verbose! display a diffstat of what changed upstream
16 q,quiet! be quiet. implies --no-stat
17 autostash automatically stash/stash pop before and after
18 fork-point use 'merge-base --fork-point' to refine upstream
19 onto=! rebase onto given branch instead of upstream
20 p,preserve-merges! try to recreate merges instead of ignoring them
21 s,strategy=! use the given merge strategy
22 no-ff! cherry-pick all commits, even if unchanged
23 m,merge! use merging strategies to rebase
24 i,interactive! let the user edit the list of commits to rebase
25 x,exec=! add exec lines after each commit of the editable list
26 k,keep-empty preserve empty commits during rebase
27 f,force-rebase! force rebase even if branch is up to date
28 X,strategy-option=! pass the argument through to the merge strategy
29 stat! display a diffstat of what changed upstream
30 n,no-stat! do not show diffstat of what changed upstream
31 verify allow pre-rebase hook to run
32 rerere-autoupdate allow rerere to update index with resolved conflicts
33 root! rebase all reachable commits up to the root(s)
34 autosquash move commits that begin with squash!/fixup! under -i
35 committer-date-is-author-date! passed to 'git am'
36 ignore-date! passed to 'git am'
37 signoff passed to 'git am'
38 whitespace=! passed to 'git apply'
39 ignore-whitespace! passed to 'git apply'
40 C=! passed to 'git apply'
41 S,gpg-sign? GPG-sign commits
44 abort! abort and check out the original branch
45 skip! skip current patch and continue
46 edit-todo! edit the todo list during an interactive rebase
47 quit! abort but keep HEAD where it is
50 set_reflog_action rebase
51 require_work_tree_exists
56 ok_to_skip_pre_rebase=
58 $(gettext 'When you have resolved this problem, run "git rebase --continue".
59 If you prefer to skip this patch, run "git rebase --skip" instead.
60 To check out the original branch and stop rebasing, run "git rebase --abort".')
63 unset restrict_revision
68 merge_dir="$GIT_DIR"/rebase-merge
69 apply_dir="$GIT_DIR"/rebase-apply
72 test "$(git config --bool rebase.stat)" = true && diffstat=t
73 autostash="$(git config --bool rebase.autostash || echo false)"
79 allow_rerere_autoupdate=
80 # Non-empty if a rebase was in progress when 'git rebase' was invoked
82 # One of {am, merge, interactive}
84 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
86 # One of {'', continue, skip, abort}, as parsed from command line
91 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
92 case "$(git config --bool commit.gpgsign)" in
93 true) gpg_sign_opt=-S ;;
98 test -f "$state_dir/head-name" &&
99 test -f "$state_dir/onto" &&
100 head_name=$(cat "$state_dir"/head-name) &&
101 onto=$(cat "$state_dir"/onto) &&
102 # We always write to orig-head, but interactive rebase used to write to
103 # head. Fall back to reading from head to cover for the case that the
104 # user upgraded git with an ongoing interactive rebase.
105 if test -f "$state_dir"/orig-head
107 orig_head=$(cat "$state_dir"/orig-head)
109 orig_head=$(cat "$state_dir"/head)
111 GIT_QUIET=$(cat "$state_dir"/quiet) &&
112 test -f "$state_dir"/verbose && verbose=t
113 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
114 test -f "$state_dir"/strategy_opts &&
115 strategy_opts="$(cat "$state_dir"/strategy_opts)"
116 test -f "$state_dir"/allow_rerere_autoupdate &&
117 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
118 test -f "$state_dir"/gpg_sign_opt &&
119 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
122 write_basic_state () {
123 echo "$head_name" > "$state_dir"/head-name &&
124 echo "$onto" > "$state_dir"/onto &&
125 echo "$orig_head" > "$state_dir"/orig-head &&
126 echo "$GIT_QUIET" > "$state_dir"/quiet &&
127 test t = "$verbose" && : > "$state_dir"/verbose
128 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
129 test -n "$strategy_opts" && echo "$strategy_opts" > \
130 "$state_dir"/strategy_opts
131 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
132 "$state_dir"/allow_rerere_autoupdate
133 test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
141 test $status != 0 && printf "%s\n" "$output"
150 move_to_original_branch () {
153 message="rebase finished: $head_name onto $onto"
154 git update-ref -m "$message" \
155 $head_name $(git rev-parse HEAD) $orig_head &&
157 -m "rebase finished: returning to $head_name" \
159 die "$(eval_gettext "Could not move back to \$head_name")"
165 if test -f "$state_dir/autostash"
167 stash_sha1=$(cat "$state_dir/autostash")
168 if git stash apply $stash_sha1 2>&1 >/dev/null
170 echo "$(gettext 'Applied autostash.')" >&2
172 git stash store -m "autostash" -q $stash_sha1 ||
173 die "$(eval_gettext "Cannot store \$stash_sha1")"
174 gettext 'Applying autostash resulted in conflicts.
175 Your changes are safe in the stash.
176 You can run "git stash pop" or "git stash drop" at any time.
184 { git gc --auto || true; } &&
188 run_specific_rebase () {
189 if [ "$interactive_rebase" = implied ]; then
199 elif test $ret -eq 2 # special exit status for rebase -i
202 rm -rf "$state_dir" &&
208 run_pre_rebase_hook () {
209 if test -z "$ok_to_skip_pre_rebase" &&
210 test -x "$(git rev-parse --git-path hooks/pre-rebase)"
212 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
213 die "$(gettext "The pre-rebase hook refused to rebase.")"
217 test -f "$apply_dir"/applying &&
218 die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
220 if test -d "$apply_dir"
223 state_dir="$apply_dir"
224 elif test -d "$merge_dir"
226 if test -f "$merge_dir"/interactive
229 interactive_rebase=explicit
233 state_dir="$merge_dir"
235 test -n "$type" && in_progress=t
242 ok_to_skip_pre_rebase=yes
245 ok_to_skip_pre_rebase=
247 --continue|--skip|--abort|--quit|--edit-todo)
248 test $total_argc -eq 2 || usage
255 cmd="${cmd}exec ${1#--exec=}${LF}"
256 test -z "$interactive_rebase" && interactive_rebase=implied
259 interactive_rebase=explicit
266 test -z "$interactive_rebase" && interactive_rebase=implied
284 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
286 test -z "$strategy" && strategy=recursive
289 strategy="${1#--strategy=}"
311 git_am_opt="$git_am_opt -q"
316 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
317 case "${1#--whitespace=}" in
324 git_am_opt="$git_am_opt $1"
326 --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
327 git_am_opt="$git_am_opt $1"
331 git_am_opt="$git_am_opt $1"
336 --force-rebase|--no-ff)
339 --rerere-autoupdate|--no-rerere-autoupdate)
340 allow_rerere_autoupdate="$1"
346 gpg_sign_opt="-S${1#--gpg-sign=}"
355 test $# -gt 2 && usage
359 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
360 # Only interactive rebase uses detailed reflog messages
361 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
363 GIT_REFLOG_ACTION="rebase -i ($action)"
364 export GIT_REFLOG_ACTION
368 if test "$action" = "edit-todo" && test "$type" != "interactive"
370 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
376 git rev-parse --verify HEAD >/dev/null ||
377 die "$(gettext "Cannot read HEAD")"
378 git update-index --ignore-submodules --refresh &&
379 git diff-files --quiet --ignore-submodules || {
380 echo "$(gettext "You must edit all merge conflicts and then
381 mark them as resolved using git add")"
388 output git reset --hard HEAD || exit $?
397 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
398 die "$(eval_gettext "Could not move back to \$head_name")"
401 output git reset --hard $orig_head
406 exec rm -rf "$state_dir"
413 # Make sure no rebase is in progress
414 if test -n "$in_progress"
416 state_dir_base=${state_dir##*/}
417 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
418 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
420 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
421 I wonder if you are in the middle of another rebase. If that is the
424 If that is not the case, please
425 $cmd_clear_stale_rebase
426 and run me again. I am stopping in case you still have something
430 if test -n "$rebase_root" && test -z "$onto"
432 test -z "$interactive_rebase" && interactive_rebase=implied
435 if test -n "$interactive_rebase"
438 state_dir="$merge_dir"
439 elif test -n "$do_merge"
442 state_dir="$merge_dir"
445 state_dir="$apply_dir"
448 if test -t 2 && test -z "$GIT_QUIET"
450 git_format_patch_opt="$git_format_patch_opt --progress"
453 if test -z "$rebase_root"
457 if ! upstream_name=$(git rev-parse --symbolic-full-name \
458 --verify -q @{upstream} 2>/dev/null)
461 error_on_missing_default_upstream "rebase" "rebase" \
462 "against" "git rebase $(gettext '<branch>')"
465 test "$fork_point" = auto && fork_point=t
467 *) upstream_name="$1"
468 if test "$upstream_name" = "-"
470 upstream_name="@{-1}"
475 upstream=$(peel_committish "${upstream_name}") ||
476 die "$(eval_gettext "invalid upstream \$upstream_name")"
477 upstream_arg="$upstream_name"
481 empty_tree=$(git hash-object -t tree /dev/null)
482 onto=$(git commit-tree $empty_tree </dev/null)
487 test $# -gt 1 && usage
491 # Make sure the branch to rebase onto is valid.
492 onto_name=${onto-"$upstream_name"}
495 if left=${onto_name%...*} right=${onto_name#*...} &&
496 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
500 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
503 die "$(eval_gettext "\$onto_name: there is no merge base")"
507 die "$(eval_gettext "\$onto_name: there is no merge base")"
511 onto=$(peel_committish "$onto_name") ||
512 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
516 # If the branch to rebase is given, that is the branch we will rebase
517 # $branch_name -- branch being rebased, or HEAD (already detached)
518 # $orig_head -- commit object name of tip of the branch before rebasing
519 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
523 # Is it "rebase other $branchname" or "rebase other $commit"?
527 if git show-ref --verify --quiet -- "refs/heads/$1" &&
528 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
530 head_name="refs/heads/$1"
531 elif orig_head=$(git rev-parse -q --verify "$1")
533 head_name="detached HEAD"
535 die "$(eval_gettext "fatal: no such branch: \$branch_name")"
539 # Do not need to switch branches, we are already on it.
540 if branch_name=$(git symbolic-ref -q HEAD)
542 head_name=$branch_name
543 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
545 head_name="detached HEAD"
546 branch_name=HEAD ;# detached
548 orig_head=$(git rev-parse --verify HEAD) || exit
551 die "BUG: unexpected number of arguments left to parse"
555 if test "$fork_point" = t
557 new_upstream=$(git merge-base --fork-point "$upstream_name" \
558 "${switch_to:-HEAD}")
559 if test -n "$new_upstream"
561 restrict_revision=$new_upstream
565 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
567 stash_sha1=$(git stash create "autostash") ||
568 die "$(gettext 'Cannot autostash')"
570 mkdir -p "$state_dir" &&
571 echo $stash_sha1 >"$state_dir/autostash" &&
572 stash_abbrev=$(git rev-parse --short $stash_sha1) &&
573 echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
577 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
579 # Now we are rebasing commits $upstream..$orig_head (or with --root,
580 # everything leading up to $orig_head) on top of $onto
582 # Check if we are already based on $onto with linear history,
583 # but this should be done only when upstream and onto are the same
584 # and if this is not an interactive rebase.
585 mb=$(git merge-base "$onto" "$orig_head")
586 if test "$type" != interactive && test "$upstream" = "$onto" &&
587 test "$mb" = "$onto" && test -z "$restrict_revision" &&
589 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
591 if test -z "$force_rebase"
593 # Lazily switch to the target branch if needed...
594 test -z "$switch_to" ||
595 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
596 git checkout -q "$switch_to" --
597 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
601 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
605 # If a hook exists, give it a chance to interrupt
606 run_pre_rebase_hook "$upstream_arg" "$@"
608 if test -n "$diffstat"
610 if test -n "$verbose"
612 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
614 # We want color (if set), but no pager
615 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
618 test "$type" = interactive && run_specific_rebase
620 # Detach HEAD and reset the tree
621 say "$(gettext "First, rewinding head to replay your work on top of it...")"
623 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
624 git checkout -q "$onto^0" || die "could not detach HEAD"
625 git update-ref ORIG_HEAD $orig_head
627 # If the $onto is a proper descendant of the tip of the branch, then
628 # we just fast-forwarded.
629 if test "$mb" = "$orig_head"
631 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
632 move_to_original_branch
637 if test -n "$rebase_root"
639 revisions="$onto..$orig_head"
641 revisions="${restrict_revision-$upstream}..$orig_head"